''' <summary>
''' Diese Auflistung gewhrleistet, dass beim Entfernen eines Elementes dessen 
'''  Ressourcen freigegeben werden
''' </summary>
Public NotInheritable Class DisposeList(Of T As IDisposable)
    Inherits System.Collections.ObjectModel.Collection(Of T)
    Implements IDisposable

    ' Die Grund-Idee zu einer solchen Klasse stammt von Robert Closheim

    Protected Overrides Sub ClearItems() Implements IDisposable.Dispose
        For Each d As T In Me
            Debug.WriteLine("DisposeList disposes: " & d.GetType.Name)
            d.Dispose()
        Next
        MyBase.ClearItems()
    End Sub

    Protected Overrides Sub RemoveItem(ByVal index As Integer)
        Debug.WriteLine("DisposeList disposes: " & Me(index).GetType.Name)
        Me(index).Dispose()
        MyBase.RemoveItem(index)
    End Sub

End Class
